6813402: keytool cannot -printcert entries without extensions
Reviewed-by: xuelei
--- a/jdk/src/share/classes/sun/security/tools/KeyTool.java Wed Mar 04 09:26:41 2009 -0800
+++ b/jdk/src/share/classes/sun/security/tools/KeyTool.java Thu Mar 05 14:49:55 2009 +0800
@@ -1910,7 +1910,9 @@
ObjectIdentifier oid = attr.getAttributeId();
if (oid.equals(PKCS9Attribute.EXTENSION_REQUEST_OID)) {
CertificateExtensions exts = (CertificateExtensions)attr.getAttributeValue();
- printExtensions(rb.getString("Extension Request:"), exts, out);
+ if (exts != null) {
+ printExtensions(rb.getString("Extension Request:"), exts, out);
+ }
} else {
out.println(attr.getAttributeId());
out.println(attr.getAttributeValue());
@@ -2495,7 +2497,9 @@
X509CertImpl.INFO);
CertificateExtensions exts = (CertificateExtensions)
certInfo.get(X509CertInfo.EXTENSIONS);
- printExtensions(rb.getString("Extensions: "), exts, out);
+ if (exts != null) {
+ printExtensions(rb.getString("Extensions: "), exts, out);
+ }
}
}
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/jdk/test/sun/security/tools/keytool/NoExtNPE.sh Thu Mar 05 14:49:55 2009 +0800
@@ -0,0 +1,65 @@
+#
+# Copyright 2009 Sun Microsystems, Inc. All Rights Reserved.
+# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+#
+# This code is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 2 only, as
+# published by the Free Software Foundation.
+#
+# This code is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
+# version 2 for more details (a copy is included in the LICENSE file that
+# accompanied this code).
+#
+# You should have received a copy of the GNU General Public License version
+# 2 along with this work; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
+# CA 95054 USA or visit www.sun.com if you need additional information or
+# have any questions.
+#
+
+# @test
+# @bug 6813402
+# @summary keytool cannot -printcert entries without extensions
+#
+# @run shell NoExtNPE.sh
+
+# set a few environment variables so that the shell-script can run stand-alone
+# in the source directory
+if [ "${TESTSRC}" = "" ] ; then
+ TESTSRC="."
+fi
+
+if [ "${TESTJAVA}" = "" ] ; then
+ echo "TESTJAVA not set. Test cannot execute."
+ echo "FAILED!!!"
+ exit 1
+fi
+
+# set platform-dependent variables
+OS=`uname -s`
+case "$OS" in
+ SunOS )
+ FILESEP="/"
+ ;;
+ Linux )
+ FILESEP="/"
+ ;;
+ Windows* )
+ FILESEP="\\"
+ ;;
+ * )
+ echo "Unrecognized system!"
+ exit 1;
+ ;;
+esac
+
+${TESTJAVA}${FILESEP}bin${FILESEP}keytool \
+ -list -v \
+ -keystore ${TESTSRC}${FILESEP}CloneKeyAskPassword.jks \
+ -storepass test123
+
+exit $?